# -*- coding: utf-8 -*-
"""xgboost.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1GmPHmDB11IneeJr8pKExPAxromWrK2VM
"""

import pandas as pd
from sklearn.preprocessing import MinMaxScaler
from sklearn.model_selection import train_test_split
from sklearn.metrics import classification_report, confusion_matrix
from sklearn.ensemble import GradientBoostingClassifier
from xgboost import XGBClassifier

import logging
import pandas as pd
import sklearn
from sklearn.feature_extraction.text import TfidfVectorizer 
import numpy as np
import matplotlib.pyplot as plt

logging.basicConfig(filename="XGBOOST.log", 
                    format='%(asctime)s %(message)s', 
                    filemode='w') 
logger=logging.getLogger() 
  
logger.setLevel(logging.DEBUG)
support=open("support.txt","r").readlines()
bully=open("bully.txt","r").readlines()

class xgboost:
  def __init__(self):
    self.train()

  def train(self):
    try:
      support=open("support.txt","r").readlines()
      bully=open("bully.txt","r").readlines()
    except:
      logger.warning("Errors may be encountered while reading file")

    label=[]
    comm=[]
    for i in bully:
      label.append('bullying')
      comm.append(i[:-1].lower())

    for i in support:
      label.append('support')
      comm.append(i[:-1].lower())
    df = pd.DataFrame({'sentence':comm, 'label':label})    
    logger.info("Loading the features")
    try:
      f=open("features.txt","r").readlines()
    except:
      logger.warning("Errors may be encountered while reading features file")
    features=[]
    for i in f:
      features.append(i[:-1].lower())    

    ##TfidfVectorizer
    tfidfconverter = TfidfVectorizer(max_features=2000,vocabulary=features,ngram_range=(1, 3))  
    X = tfidfconverter.fit_transform(comm).toarray()
    logger.info("Vectorization using tfidf")

    idf=tfidfconverter.idf_
    rr=dict(zip(tfidfconverter.get_feature_names(), idf))
    pd.DataFrame(rr.items())

    feature_names = np.array(tfidfconverter.get_feature_names())
    sorted_by_idf = np.argsort(tfidfconverter.idf_)
    print("Features with lowest idf:\n{}".format(
          feature_names[sorted_by_idf[:3]]))


    from sklearn.model_selection import train_test_split  
    X_train, X_test, y_train, y_test = train_test_split(X, label, test_size=0.2, random_state=0,stratify=label)
    logger.info("Splitting into test and training ")

    xgb_clf=XGBClassifier()
    xgb_clf.fit(X_train,y_train)
    logger.info("Training the classifier")

    predictions = xgb_clf.predict(X_test)
    from sklearn.metrics import classification_report, confusion_matrix, accuracy_score

    print(confusion_matrix(y_test,predictions))  
    print(classification_report(y_test,predictions))  
    print(accuracy_score(y_test, predictions))
    logger.info("Displaying the accuracy")

    input=['poli annu mwone','nee ninte vettil poyy para thendi']
    o=tfidfconverter.fit_transform(input).toarray()
    predict=xgb_clf.predict(o)
    print(input,predict)

xgboost()